#!/usr/bin/env fish

abbr d 'dotfiles'

abbr da 'dotfiles add'
abbr daa 'dotfiles add --all'
abbr dapa 'dotfiles add --patch'
abbr dau 'dotfiles add --update'
abbr dav 'dotfiles add --verbose'
abbr dap 'dotfiles apply'
abbr dapt 'dotfiles apply --3way'

abbr db 'dotfiles branch'
abbr dba 'dotfiles branch -a'
abbr dbd 'dotfiles branch -d'
abbr dbdf 'dotfiles branch -d -f'
abbr dbD 'dotfiles branch -D'
abbr dbDf 'dotfiles branch -D -f'
abbr dbnm 'dotfiles branch --no-merged'
abbr dbr 'dotfiles branch --remote'

abbr dbl 'dotfiles blame -b -w'

abbr dbs 'dotfiles bisect'
abbr dbsb 'dotfiles bisect bad'
abbr dbsg 'dotfiles bisect good'
abbr dbsr 'dotfiles bisect reset'
abbr dbss 'dotfiles bisect start'

abbr dc 'dotfiles commit -v'
abbr dci 'dotfiles commit --allow-empty -v -m\'chore: initial commit\''
abbr dc! 'dotfiles commit -v --amend'
abbr dcn 'dotfiles commit -v --no-edit'
abbr dcn! 'dotfiles commit -v --amend --no-edit'
abbr dca 'dotfiles commit -a -v'
abbr dca! 'dotfiles commit -a -v --amend'
abbr dcan! 'dotfiles commit -a -v --no-edit --amend'
abbr dcans! 'dotfiles commit -a -v -s --no-edit --amend'
abbr dcam 'dotfiles commit -a -m'
abbr dcas 'dotfiles commit -a -s'
abbr dcasm 'dotfiles commit -a -s -m'
abbr dcsm 'dotfiles commit -s -m'
abbr dcm 'dotfiles commit -m'
abbr dcs 'dotfiles commit -S'

abbr dcf 'dotfiles config --list'

abbr dcl 'dotfiles clone --recurse-submodules'

abbr dclean 'dotfiles clean -id'

abbr dco 'dotfiles checkout'
abbr dcob 'dotfiles checkout -b'
abbr dcom 'dotfiles checkout (git_main_branch)'
abbr dcod 'dotfiles checkout (git_develop_branch)'
abbr dcof 'dotfiles checkout (git_feature_prepend)/'
abbr dcoh 'dotfiles checkout hotfix/'
abbr dcor 'dotfiles checkout release/'
abbr dcos 'dotfiles checkout support/'
abbr dcors 'dotfiles checkout --recurse-submodules'

abbr dcount 'dotfiles shortlog -sn'

abbr dcp 'dotfiles cherry-pick'
abbr dcpa 'dotfiles cherry-pick --abort'
abbr dcpc 'dotfiles cherry-pick --continue'

abbr dd 'dotfiles diff'
abbr ddca 'dotfiles diff --cached'
abbr ddcw 'dotfiles diff --cached --word-diff'
abbr ddct 'dotfiles diff --staged'
abbr ddt 'dotfiles diff-tree --no-commit-id --name-only -r'
# abbr gdnolock 'dotfiles diff ":(exclude)package-lock.json" ":(exclude)*.lock"'
abbr ddup 'dotfiles diff @{upstream}'
# abbr gdv 'dotfiles diff -w $@ | view -'

abbr ddct 'dotfiles describe --tags (git rev-list --tags --max-count=1)'

abbr df 'dotfiles fetch'
abbr dfa 'dotfiles fetch --all --prune'
abbr dfo 'dotfiles fetch origin'

# gg
# gga
# ggf
# ggfl
# ggl
# ggp
# ggpnp
# ggpull
# ggpur
# ggpush
# ggsup
# ggu
# gpsup

abbr dhh 'dotfiles help'

abbr di 'dotfiles init'

abbr dignore 'dotfiles update-index --assume-unchanged'
abbr dignored 'dotfiles ls-files -v | grep "^[[:lower:]]"'

abbr dk 'dotfilesk --all --branches &!'
abbr dke 'dotfilesk --all (git log -g --pretty=%h) &!'

abbr dfg 'dotfiles ls-files | grep'

# gl: git log
abbr dl 'dotfiles log'
abbr dls 'dotfiles log --stat'
abbr dlsp 'dotfiles log --stat -p'
abbr dlg 'dotfiles log --graph'
abbr dlgda 'dotfiles log --graph --decorate --all'
abbr dlgm 'dotfiles log --graph --max-count=10'
abbr dlo 'dotfiles log --oneline --decorate'
abbr dlog 'dotfiles log --oneline --decorate --graph'
abbr dloga 'dotfiles log --oneline --decorate --graph --all'
# abbr glol
# abbr glols
# abbr glod
# abbr glods
# abbr glola

# gm: git merge
abbr dm 'dotfiles merge'
abbr dmom 'dotfiles merge origin/(git_main_branch)'
abbr dmum 'dotfiles merge upstream/(git_main_branch)'
abbr dma 'dotfiles merge --abort'

# gmtl: git mergetool
abbr dmtl 'dotfiles mergetool --no-prompt'
abbr dmtlvim 'dotfiles mergetool --no-prompt --tool=vimdiff'

# gp: git push
abbr dp 'dotfiles push'
abbr dpd 'dotfiles push --dry-run'
abbr dpf 'dotfiles push --force-with-lease'
abbr dpf! 'dotfiles push --force'
abbr dpsu 'dotfiles push --set-upstream origin (git_current_branch)'
abbr dpt 'dotfiles push --tags'
abbr dptf 'dotfiles push --tags --force-with-lease'
abbr dptf! 'dotfiles push --tags --force'
abbr dpoat 'dotfiles push origin --all && git push origin --tags'
abbr dpoatf! 'dotfiles push origin --all --force-with-lease && git push origin --tags --force-with-lease'
abbr dpoatf! 'dotfiles push origin --all --force && git push origin --tags --force'
abbr dpv 'dotfiles push -v'

# gpl: git pull
abbr dpl 'dotfiles pull'
abbr dplo 'dotfiles pull origin'
abbr dplom 'dotfiles pull origin (git_main_branch)'
abbr dplu 'dotfiles pull upstream'
abbr dplum 'dotfiles pull upstream (git_main_branch)'

# gr: git remote
abbr dr 'dotfiles remote -v'
abbr dra 'dotfiles remote add'
abbr drau 'dotfiles remote add upstream'
abbr drrm 'dotfiles remote remove'
abbr drmv 'dotfiles remote rename'
abbr drset 'dotfiles remote set-url'
abbr dru 'dotfiles remote update'
abbr drv 'dotfiles remote -v'
abbr drvv 'dotfiles remote -vvv'

# grb: git rebase
abbr drb 'dotfiles rebase'
abbr drba 'dotfiles rebase --abort'
abbr drbc 'dotfiles rebase --continue'
abbr drbd 'dotfiles rebase (git_develop_branch)'
abbr drbi 'dotfiles rebase -i'
abbr drbom 'dotfiles rebase origin/(git_main_branch)'
abbr drbo 'dotfiles rebase --onto'
abbr drbs 'dotfiles rebase --skip'

# grev: git revert
abbr drev 'dotfiles revert'

# grs: git reset
abbr drs 'dotfiles reset'
abbr drs! 'dotfiles reset --hard'
abbr drsh 'dotfiles reset HEAD'
abbr drsh! 'dotfiles reset HEAD --hard'
abbr drsoh 'dotfiles reset origin/(git_current_branch)'
abbr drsoh! 'dotfiles reset origin/(git_current_branch) --hard'
abbr dpristine 'dotfiles reset --hard && git clean -dffx'
abbr drs- 'dotfiles reset --'

# grm: git rm
abbr drm 'dotfiles rm'
abbr drmc 'dotfiles rm --cached'

# grst: git restore
abbr drst 'dotfiles restore'
abbr drsts 'dotfiles restore --source'
abbr drstst 'dotfiles restore --staged'

# grt: git return
abbr drt 'cd (git rev-parse --show-toplevel || echo .)'

# gs: git status
abbr ds 'dotfiles status'
abbr dss 'dotfiles status -s'
abbr dsb 'dotfiles status -sb'

# gshow: git show
abbr dshow 'dotfiles show'
abbr dshowps 'dotfiles show --pretty=short --show-signature'

# gst: git stash
abbr dst 'dotfiles stash'
abbr dsta 'dotfiles stash apply'
abbr dstc 'dotfiles stash clear'
abbr dstd 'dotfiles stash drop'
abbr dstl 'dotfiles stash list'
abbr dstp 'dotfiles stash pop'
abbr dstshow 'dotfiles stash show --text'
abbr dstall 'dotfiles stash --all'
abbr dsts 'dotfiles stash save'

# gsu: git submodule
abbr dsu 'dotfiles submodule update'

# gsw: git switch
abbr dsw 'dotfiles switch'
abbr dswc 'dotfiles switch -c'
abbr dswm 'dotfiles switch (git_main_branch)'
abbr dswd 'dotfiles switch (git_develop_branch)'

# gt: git tag
abbr dt 'dotfiles tag'
abbr dts 'dotfiles tag -s'
abbr dta 'dotfiles tag -a'
abbr dtas 'dotfiles tag -a -s'
# gtl

# gwch: git whatchanged
abbr dwch 'dotfiles whatchanged -p --abbrev-commit --pretty=medium'

# gwt: git worktree
abbr dwt 'dotfiles worktree'
abbr dwta 'dotfiles worktree add'
abbr dwtls 'dotfiles worktree list'
abbr dwtmv 'dotfiles worktree move'
abbr dwtrm 'dotfiles worktree remove'

# gam: git am
abbr dam 'dotfiles am'
abbr damc 'dotfiles am --continue'
abbr dams 'dotfiles am --skip'
abbr dama 'dotfiles am --abort'
abbr damscp 'dotfiles am --show-current-patch'

function dotfiles_abbr_uninstall --on-event git_abbr_uninstall
  abbr -e d
  abbr -e da
  abbr -e daa
  abbr -e dapa
  abbr -e dau
  abbr -e dav
  abbr -e dap
  abbr -e dapt
  abbr -e db
  abbr -e dba
  abbr -e dbd
  abbr -e dbDf
  abbr -e dbD
  abbr -e dbDf
  abbr -e dbnm
  abbr -e dbr
  abbr -e dbl
  abbr -e dbs
  abbr -e dbsb
  abbr -e dbsg
  abbr -e dbsr
  abbr -e dbss
  abbr -e dc
  abbr -e dci
  abbr -e dc!
  abbr -e dcn
  abbr -e dcn!
  abbr -e dca
  abbr -e dca!
  abbr -e dcan!
  abbr -e dcans!
  abbr -e dcam
  abbr -e dcas
  abbr -e dcasm
  abbr -e dcsm
  abbr -e dcm
  abbr -e dcs
  abbr -e dcf
  abbr -e dcl
  abbr -e dclean
  abbr -e dco
  abbr -e dcob
  abbr -e dcom
  abbr -e dcod
  abbr -e dcof
  abbr -e dcoh
  abbr -e dcor
  abbr -e dcos
  abbr -e dcors
  abbr -e dcount
  abbr -e dcp
  abbr -e dcpa
  abbr -e dcpc
  abbr -e dd
  abbr -e ddca
  abbr -e ddcw
  abbr -e ddct
  abbr -e ddt
  abbr -e ddup
  abbr -e ddct
  abbr -e df
  abbr -e dfa
  abbr -e dfo
  abbr -e dhh
  abbr -e di
  abbr -e dignore
  abbr -e dignored
  abbr -e dk
  abbr -e dke
  abbr -e dfg
  abbr -e dl
  abbr -e dls
  abbr -e dlsp
  abbr -e dlg
  abbr -e dlgda
  abbr -e dlgm
  abbr -e dlo
  abbr -e dlog
  abbr -e dloga
  abbr -e dm
  abbr -e dmom
  abbr -e dmum
  abbr -e dma
  abbr -e dmtl
  abbr -e dmtlvim
  abbr -e dp
  abbr -e dpd
  abbr -e dpf
  abbr -e dpf!
  abbr -e dpt
  abbr -e dptf
  abbr -e dptf!
  abbr -e dpoat
  abbr -e dpoatf!
  abbr -e dpoatf!
  abbr -e dpv
  abbr -e dpl
  abbr -e dplo
  abbr -e dplom
  abbr -e dplu
  abbr -e dplum
  abbr -e dr
  abbr -e dra
  abbr -e drau
  abbr -e drrm
  abbr -e drmv
  abbr -e drset
  abbr -e dru
  abbr -e drv
  abbr -e drvv
  abbr -e drb
  abbr -e drba
  abbr -e drbc
  abbr -e drbd
  abbr -e drbi
  abbr -e drbom
  abbr -e drbo
  abbr -e drbs
  abbr -e drev
  abbr -e drs
  abbr -e drs!
  abbr -e drsh
  abbr -e drsh!
  abbr -e drsoh
  abbr -e drsoh!
  abbr -e dpristine
  abbr -e drs-
  abbr -e drm
  abbr -e drmc
  abbr -e drst
  abbr -e drsts
  abbr -e drstst
  abbr -e drt
  abbr -e ds
  abbr -e dss
  abbr -e dsb
  abbr -e dshow
  abbr -e dshowps
  abbr -e dst
  abbr -e dsta
  abbr -e dstc
  abbr -e dstd
  abbr -e dstl
  abbr -e dstp
  abbr -e dstshow
  abbr -e dstall
  abbr -e dsts
  abbr -e dsu
  abbr -e dsw
  abbr -e dswc
  abbr -e dswm
  abbr -e dswd
  abbr -e dt
  abbr -e dts
  abbr -e dta
  abbr -e dtas
  abbr -e dwch
  abbr -e dwt
  abbr -e dwta
  abbr -e dwtls
  abbr -e dwtmv
  abbr -e dwtrm
  abbr -e dam
  abbr -e damc
  abbr -e dams
  abbr -e dama
  abbr -e damscp
end
